free-4.12.4: Monads for free

Copyright | (C) 2008-2011 Edward Kmett
License | BSD-style (see the file LICENSE)
Maintainer | Edward Kmett <ekmett@gmail.com>
Stability | experimental
Portability | fundeps, MPTCs
Safe Haskell | Safe
Language | Haskell2010

Control.Comonad.Cofree.Class

Description

Synopsis

- class (Functor f, Comonad w) => ComonadCofree f w | w -> f where

# Documentation

class (Functor f, Comonad w) => ComonadCofree f w | w -> f where Source #

Allows you to peel a layer off a cofree comonad.

Minimal complete definition

unwrap

Methods

unwrap :: w a -> f (w a) Source #

Remove a layer.

Instances

ComonadCofree [] Tree Source # |
Methods unwrap :: Tree a -> [Tree a] Source #
ComonadCofree Maybe NonEmpty Source # |
Methods unwrap :: NonEmpty a -> Maybe (NonEmpty a) Source #
Functor f => ComonadCofree f (Cofree f) Source # |
Methods unwrap :: Cofree f a -> f (Cofree f a) Source #
Comonad w => ComonadCofree Identity (CoiterT w) Source # |
Methods unwrap :: CoiterT w a -> Identity (CoiterT w a) Source #
(ComonadCofree f w, Monoid m) => ComonadCofree f (TracedT m w) Source # |
Methods unwrap :: TracedT m w a -> f (TracedT m w a) Source #
ComonadCofree f w => ComonadCofree f (StoreT s w) Source # |
Methods unwrap :: StoreT s w a -> f (StoreT s w a) Source #
ComonadCofree f w => ComonadCofree f (EnvT e w) Source # |
Methods unwrap :: EnvT e w a -> f (EnvT e w a) Source #
ComonadCofree f w => ComonadCofree f (IdentityT * w) Source # |
Methods unwrap :: IdentityT * w a -> f (IdentityT * w a) Source #
(Functor f, Comonad w) => ComonadCofree f (CofreeT f w) Source # |
Methods unwrap :: CofreeT f w a -> f (CofreeT f w a) Source #
ComonadCofree (Const * b) ((,) b) Source # |
Methods unwrap :: (b, a) -> Const * b (b, a) Source #